#include <stdio.h>
#include <stdlib.h>

#include <signal.h>

void my_handler(int signo, siginfo_t *si, void*ucontext){
	printf("\nI have a signal\n");
	if(si){
	   printf("The num is..[%d]",(*si).si_value.sival_int);
	}else{
	   perror("sigqueue");
	}
}

int main(){
	int pid;
	struct sigaction new_action;
	sigval_t value;

	new_action.sa_handler = my_handler;
        sigemptyset (&new_action.sa_mask);
        new_action.sa_flags = SA_SIGINFO|SA_NODEFER;

	value.sival_int=202;
	sigaction(SIGUSR1,&new_action,NULL);

	
	if  (pid = fork()) {
	   for (;;){
	      sleep(5);
	      if(!sigqueue(pid, SIGUSR1, value)){
		 printf("Error of sending information to pid[%d]",pid);
	      }
	      kill(pid, SIGUSR1);
	   }
	}else {
	    printf("It's not forked \n");
	    raise(SIGUSR1);
	    sleep(5);
	    kill(getppid(), SIGKILL);
	}	
	return 0;
}
